export function isDefined(value) {
    return value !== void 0;
}
export function isUndefined(value) {
    return value === void 0;
}
export function isNull(value) {
    return value === null;
}
export function isNotNull(value) {
    return value !== null;
}
export function isNothing(value) {
    return value === void 0 || value === null;
}
export function isNotNothing(value) {
    return value !== void 0 && value !== null;
}
export function isIterable(value) {
    return Symbol.iterator in value;
}
export function isObject(value) {
    return typeof value === 'object' && value !== null;
}
export function isFunction(value) {
    return typeof value === 'function';
}
export function isBoolean(value) {
    return typeof value === 'boolean';
}
export function isString(value) {
    return typeof value === 'string';
}
export function isNumber(value) {
    return typeof value === 'number';
}
export function isSymbol(value) {
    return typeof value === 'symbol';
}
export function isPlain(value) {
    return value.constructor === Object;
}
export function isInstanceOf(type) {
    function instanceOf(value) {
        return value instanceof type;
    }
    return instanceOf;
}
//# sourceMappingURL=is.js.map